/*
    This file is part of the source of talk64 V1.5,
    a PC - DoctorV64 communications program
    Copyright (C) 1997  Andreas Sterbenz (stan@sbox.tu-graz.ac.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#ifndef __GLOBAL_H__
#define __GLOBAL_H__ 1

#define max2(a, b) ( (a)>(b) ? (a) : (b) )
#define min2(a, b) ( (a)<(b) ? (a) : (b) )
#define max3(a, b, c) ( max2(a, max2(b, c)) )
#define min3(a, b, c) ( min2(a, min2(b, c)) )

#define BUFSIZE 32768
#define BUFSIZE_INT min2(0x1000, BUFSIZE)

#define BYTES2LONG(b, s) ( (((b)[0^(s)] & 0xffL) << 24) | \
                           (((b)[1^(s)] & 0xffL) << 16) | \
                           (((b)[2^(s)] & 0xffL) <<  8) | \
                           (((b)[3^(s)] & 0xffL)) )

#define LONG2BYTES(l, b, s)  (b)[0^(s)] = ((l)>>24)&0xff; \
                             (b)[1^(s)] = ((l)>>16)&0xff; \
                             (b)[2^(s)] = ((l)>> 8)&0xff; \
                             (b)[3^(s)] = ((l)    )&0xff;

#define HEADER_MAGIC 0x80371240
#define HEADER_NAME_OFFSET 0x20
#define HEADER_NAME_LEN 20

#define MODE_UNDEF 0
#define MODE_SEND 1
#define MODE_RECEIVE 2
#define MODE_INTERACTIVE 3

#define MAX_STRING_LENGTH 128

/* #define DEBUG_NOCOMM */

#define printableChar(c) ( isprint(c) ? (c) : '.' )

extern char buffer1[BUFSIZE];


extern int biosVersion;

int guessByteOrder(unsigned char rombytes[12]);

int sendBytesFromFile(int baseport, FILE *file1, long flen1, int v64format);

int receiveBytesToFile(int baseport, FILE *file1, long flen1, int v64format);

#endif
