/*
    This file is part of the source of talk64 V1.5,
    a PC - DoctorV64 communications program
    Copyright (C) 1997  Andreas Sterbenz (stan@sbox.tu-graz.ac.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#include <stdio.h>
#include <dos.h>
#include <conio.h>

#include "parsys.h"

int getKbChar(void)
{
  return getch();
}

void setInputMode(int echomode)
{
  echomode = echomode; /* 'suppress' compiler warning */
}

unsigned int getParPort(unsigned int port)
{
  int far *biosport;
  int i;

  biosport = (void *)0x00400008;
  if( port == 0 ) port = 1;
  if( port<=3 ) return biosport[port-1];
  for( i=0; i<4; i++ ) {
    if( biosport[i] != 0 ) {
      if( port == biosport[i] ) return biosport[i];
    }
  }
  if( port != 0 ) {
    printf("WARNING: Bios does not know about a parallel port at %4X!\n", port);
  }
  return port;
}

void out1byte(unsigned int port, unsigned char c)
{
  outportb(port, c);
}

unsigned char in1byte(unsigned int port)
{
  return inportb(port);
}
