#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/perm.h>

#include "global.h"
#include "parsys.h"

void out1byte(unsigned int port, unsigned char c)
{
  __asm__ volatile ("outb %0,%1"
		    ::"a" ((char) c), "d"((unsigned short) port));
}

unsigned char in1byte(unsigned int port)
{
  char _v;
  __asm__ volatile ("inb %1,%0"
		    :"=a" (_v):"d"((unsigned short) port));

  return _v;
}

int getKbChar(void)
{
//  int key = getch();
//  if( key == 127 ) { 
//    return '\b';
//  } else {
//    return key;
//  }
return 0;
}

void setInputMode(int echomode)
{
  if( echomode == INPUT_MODE_ECHO ) {
//    nocbreak();
//    echo();
  } else {
//    cbreak();
//    noecho();
  }
}

void setIoPerm(unsigned int port, int nr, int val)
{
  if( ioperm(port, nr, val) != 0 ) {
    fflush(stdout);
    fprintf(stderr, "%s: Could not acquire IO privileges for accessing port hardware.\n", progname);
    fprintf(stderr, "Make sure that this program is SUID root!\n");
    exit(1);
  }
}

#define DETECT_MAX_CNT 1000

int detectParPort(unsigned int port)
{
  int i;

  setIoPerm(port, 1, 1);
  out1byte(port, 0xaa);
  for( i=0; i<DETECT_MAX_CNT; i++ ) {
    if( in1byte(port) == 0xaa ) break;
  }
  if( i < DETECT_MAX_CNT ) {
    out1byte(port, 0x55);
    for( i=0; i<DETECT_MAX_CNT; i++ ) {
      if( in1byte(port) == 0x55 ) break;
    }
  }
  setIoPerm(port, 1, 0);
  if( i >= DETECT_MAX_CNT ) return 0;
  return 1;
}

unsigned int getParPort(unsigned int port)
{
  uid_t uid;
  unsigned int parPortAddresses[] = { 0x3bc, 0x378, 0x278 };
  int i;
  
//  initscr();
  setInputMode(INPUT_MODE_ECHO);
  if( port == 0 ) port = 1;
  if( port <= 3 ) {
    for( i=0; i<3; i++ ) {
      port -= detectParPort(parPortAddresses[i]);
      if( port == 0 ) {
        port = parPortAddresses[i];
        break;
      }
    }
    if( i >= 3 ) return 0;
  } else {
    if( (port != parPortAddresses[0]) && (port != parPortAddresses[1]) && (port != parPortAddresses[2]) ) {
      fprintf(stderr, "%s: %X is not a valid port address.\n", progname, port);
      fprintf(stderr, "Use the hardware addresses %X, %X, or %X\n", parPortAddresses[0], parPortAddresses[1], parPortAddresses[2]);
      fprintf(stderr, "or specify 1, 2, or 3 for your first, second, or third parallel port.\n");
      exit(1);
    }
  }
  if( port != 0 ) {
    setIoPerm(port, 3, 1);
    uid = getuid();
    seteuid(uid);
  }
  return port;
}
