/*
  ucon64.c
  -
  uCON64 Source Code    - Noisy Belch (noisyb@gmx.net)

  uCON unix Source Code - splice (splice@parodius.com)
                          Last Updated: July 22, 1999

  uCON DOS Version      - 1995 (Chicken & chp)
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <fcntl.h>
#include <time.h>

char arg[4096];
#define progname arg

#include "interac.h"
#include "v64prot.h"

#ifdef MSDOS
	char *uconver="991207-early-beta-msdos";
	#include "pardos.h"
	#define ARG /
#endif

#ifdef LINUX
	char *uconver="991207-early-beta-unix";
	#include "parlinux.h"
	#define ARG -
#endif

#define SNES 0
#define GENESIS 1
#define N64 2

#define char(x) (char)x
#define int(x) (int)x

double pow(double x, double y)
{
	register double x2,x3;

	x3=x;
	for(x2=0;x2<y-1;x2++)x3=x3*x;
	return x3;
}

void credits(void)
{
 printf("\"What Every Console User Needs\" - By Chicken & chp (1995)\n");
 printf("Unix port: splice\n\
Transfer routines: Andreas Sterbenz (stan@sbox.tu-graz.ac.at)\n\
IPS 1.2 and Makesram routines: madman\n\
APS 1.2 routines: Silo/Blackbag\n\
Ripped/Fixed all together into one tool by Noisy Belch/Gewalt! (noisyb@gmx.net)\n\
\nReport problems to noisyb@gmx.net\n\n");
}

char cmd[4096];
char cmd1[4096];
char cmd2[4096];
char cmd3[4096];

int comnumber;
int k=0, z=0, h=-1, kk=0, ramsize, romindex;
//int hirom=0; 
int force=0,quiet=0;
unsigned int port=0;
char readchunk[8192],readchunk2[8192];
char readchunk3[32768];
char seganame[15];

void calcandwriteheader(FILE *fileptrtodo, char *newheader)
{
	unsigned long  truesize;

	fseek(fileptrtodo, 0, SEEK_END);
	truesize=ftell(fileptrtodo);
	fseek(fileptrtodo, 0, SEEK_SET);
	truesize-=ftell(fileptrtodo);
	truesize=(truesize-512)/8192;
	newheader[1]=truesize/256;
	newheader[0]=(truesize)-(newheader[1]*256);
	fseek(fileptrtodo, 0, SEEK_SET);
	fwrite(newheader, sizeof(newheader), 1, fileptrtodo);
}

void chkiffileexist(FILE *fileptrtochk, char *filenametochk)
{
	if(fileptrtochk==NULL)
	{
	        printf("\n%s: %s: No such file or directory\n\n",arg, filenametochk);
		exit(1);
	}
}

void diskspaceerror()
{
	printf("\n%s: error: Error while writing file. Check free space.\n",arg);
	exit(255);
}

void checkminsize (unsigned long testfilesize)
{
	if (testfilesize<32768)
	{
		printf("\n%s: error: Image specified is less than .25 Mbit in length.\n\n",arg);
		exit(255);
	}
}

void z64v64(void)
{
//still in progress
	printf("Z64 <-> V64");
}

void getn64info(void)
{
  char  cartname[32];
  char  cartinfo[256][35];
  int   cartsize;
  char  makerid[256][33];
  char  countryid[256][40];
  char  format[8][32];
  float filesize;
  unsigned long file_size;
  FILE  *file_ptr;
  char  inchar[1];
  int   makerindex, countryindex, j;
  float subsize=512.0;
  signed long offset=0;
  int   power=0;
  float introsize;
int swapped;
char buffer2;
char buffer[32768];
register int x;

 cartname[22]='\0';
 for (j=0; j<255; j++)
	{
	strcpy(cartinfo[j], "<<Unknown>>");
	strcpy(countryid[j], "<<Unknown>>");
	}

 strcpy(makerid[0], "<<INVALID>>");
 strcpy(makerid[1], "Nintendo");
 strcpy(makerid[2], "<<Unknown 2>>");
 strcpy(makerid[3], "Imagineer-Zoom");
 strcpy(makerid[4], "<<Unknown 4>>");
 strcpy(makerid[5], "Zamuse");
 strcpy(makerid[6], "Falcom");
 strcpy(makerid[7], "<<Unknown 7>>");
 strcpy(makerid[8], "Capcom");
 strcpy(makerid[9], "HOT-B");
 strcpy(makerid[10], "Jaleco");
 strcpy(makerid[11], "Coconuts");
 strcpy(makerid[0x0c], "Coconuts");
 strcpy(makerid[13], "<<Unknown 13>>");
 strcpy(makerid[14], "Technos");
 strcpy(makerid[15], "Pack-In-Video");
 strcpy(makerid[16], "<<Unknown 16>>");
 strcpy(makerid[0x11], "Starfish");
 strcpy(makerid[18], "Gremlin Graphics");
 strcpy(makerid[19], "Electronic Arts");
 strcpy(makerid[20], "<<Unknown 20>>");
 strcpy(makerid[21], "Cobra Team");
 strcpy(makerid[22], "Human");
 strcpy(makerid[23], "KOEI");
 strcpy(makerid[24], "Hudson Soft");
 strcpy(makerid[25], "Yanoman");
 strcpy(makerid[26], "Yanoman");
 strcpy(makerid[27], "<<Unknown 27>>");
 strcpy(makerid[28], "Tecmo Products");
 strcpy(makerid[29], "<<Unknown 29>>");
 strcpy(makerid[30], "Open System");
 strcpy(makerid[31], "Virgin Games");
 strcpy(makerid[32], "KSS");
 strcpy(makerid[33], "Sunsoft");
 strcpy(makerid[34], "Pow");
 strcpy(makerid[35], "Micro World");
 strcpy(makerid[36], "<<Unknown 36>>");
 strcpy(makerid[37], "<<Unknown 37>>");
 strcpy(makerid[38], "Enix");
 strcpy(makerid[39], "Loriciel/Electro Brain");
 strcpy(makerid[40], "Kemco");
 strcpy(makerid[41], "Seta");
 strcpy(makerid[42], "<<Unknown 42>>");
 strcpy(makerid[43], "<<Unknown 43>>");
 strcpy(makerid[44], "<<Unknown 44>>");
 strcpy(makerid[45], "Visit");
 strcpy(makerid[46], "<<Unknown 46>>");
 strcpy(makerid[47], "<<Unknown 47>>");
 strcpy(makerid[48], "Viacom New Media");
// lmk-sio.lha
 strcpy(makerid[49], "Carrozzeria");
 strcpy(makerid[50], "Dynamic");
// strcpy(makerid[0x33], "Rumic Soft");
// Media Rings Corporation ?
// strcpy(makerid[0x33], "Saurus");
 strcpy(makerid[0x33], "<<UNDEFINED>>");
 strcpy(makerid[52], "Magifact");
// strcpy(makerid[53], "DTMC");
 strcpy(makerid[53], "Hect");
 strcpy(makerid[54], "<<Unknown 54>>");
 strcpy(makerid[55], "<<Unknown 55>>");
 strcpy(makerid[56], "<<Unknown 56>>");
 strcpy(makerid[57], "<<Unknown 57>>");
 strcpy(makerid[58], "<<Unknown 58>>");
 strcpy(makerid[59], "Arcade Zone");
 strcpy(makerid[60], "Empire Software");
// strcpy(makerid[61], "Loriciel/Electro Brain");
 strcpy(makerid[61], "Loriciel");
 strcpy(makerid[62], "<<Unknown 62>>");
 strcpy(makerid[63], "<<Unknown 63>>");
// strcpy(makerid[64], "Seika Corp.");
 strcpy(makerid[64], "Seika");
 strcpy(makerid[65], "Ubi Soft");
 strcpy(makerid[66], "<<Unknown 66>>");
 strcpy(makerid[67], "<<Unknown 67>>");
 strcpy(makerid[68], "<<Unknown 68>>");
 strcpy(makerid[69], "<<Unknown 69>>");
// PAL 246
 strcpy(makerid[70], "System 3");
 strcpy(makerid[71], "Spectrum HoloByte");
 strcpy(makerid[72], "<<Unknown 72>>");
 strcpy(makerid[73], "Irem");
 strcpy(makerid[74], "<<Unknown 74>>");
// strcpy(makerid[75], "Raya Systems/Sculptured Software");
 strcpy(makerid[75], "Raya Systems");
 strcpy(makerid[76], "Renovation Products*");
 strcpy(makerid[77], "Malibu Games");
 strcpy(makerid[78], "<<Unknown 78>>");
 strcpy(makerid[79], "U.S. Gold");
// strcpy(makerid[80], "Absolute Entertainment");
 strcpy(makerid[80], "Absolute");
 strcpy(makerid[81], "Acclaim");
 strcpy(makerid[82], "Activision");
 strcpy(makerid[83], "American Sammy");
// strcpy(makerid[84], "GameTek");
 strcpy(makerid[84], "Gametek");
// strcpy(makerid[85], "Hi-Tech Expressions Inc.");
// strcpy(makerid[85], "Hi-Tech Expressions");
// strcpy(makerid[85], "Hi Tech Expressions");
 strcpy(makerid[85], "Hi Tech Entertainment");
 strcpy(makerid[86], "LJN");
 strcpy(makerid[87], "<<Unknown 87>>");
 strcpy(makerid[88], "<<Unknown 88>>");
 strcpy(makerid[89], "<<Unknown 89>>");
 strcpy(makerid[90], "Mindscape");
 strcpy(makerid[91], "<<Unknown 91>>");
 strcpy(makerid[92], "<<Unknown 92>>");
 strcpy(makerid[93], "Tradewest");
 strcpy(makerid[94], "<<Unknown 94>>");
// strcpy(makerid[95], "American Softworks Corp.");
 strcpy(makerid[95], "American Softworks");
 strcpy(makerid[96], "Titus");
// strcpy(makerid[97], "Virgin Games");
 strcpy(makerid[97], "Virgin Interactive Entertainment");
 strcpy(makerid[98], "Maxis*");
 strcpy(makerid[99], "Origin/FCI/Pony Canyon");
 strcpy(makerid[100], "<<Unknown 100>>");
 strcpy(makerid[101], "<<Unknown 101>>");
 strcpy(makerid[102], "<<Unknown 102>>");
 strcpy(makerid[103], "Ocean");
 strcpy(makerid[104], "<<Unknown 104>>");
 strcpy(makerid[105], "Electronic Arts");
 strcpy(makerid[106], "<<Unknown 106>>");
 strcpy(makerid[107], "Laserbeam");
 strcpy(makerid[108], "<<Unknown 108>>");
 strcpy(makerid[109], "<<Unknown 109>>");
 strcpy(makerid[110], "Elite");
 strcpy(makerid[111], "Electro Brain");
 strcpy(makerid[112], "Infogrames");
 strcpy(makerid[113], "Interplay");
 strcpy(makerid[114], "LucasArts");
// strcpy(makerid[115], "Parker Bros.");
// strcpy(makerid[115], "Waddington Games");
 strcpy(makerid[115], "Parker Brothers");
 strcpy(makerid[116], "Konami");
 strcpy(makerid[117], "STORM*");
 strcpy(makerid[118], "<<Unknown 118>>");
 strcpy(makerid[119], "<<Unknown 119>>");
// strcpy(makerid[120], "T*HQ Software");
 strcpy(makerid[120], "T*HQ");
// strcpy(makerid[121], "Accolade Inc.");
 strcpy(makerid[121], "Accolade");
 strcpy(makerid[122], "Triffix");
 strcpy(makerid[123], "<<Unknown 123>>");
 strcpy(makerid[124], "Microprose");
 strcpy(makerid[125], "<<Unknown 125>>");
 strcpy(makerid[126], "<<Unknown 126>>");
 strcpy(makerid[127], "Kemco");
// strcpy(makerid[128], "Misawa Entertainment Co.,Ltd.");
 strcpy(makerid[128], "Misawa");
// strcpy(makerid[129], "Teichio Co. Ltd.");
 strcpy(makerid[129], "Teichio");
 strcpy(makerid[130], "Namco");
 strcpy(makerid[131], "Lozc");
// strcpy(makerid[132], "KOEI/KOEI!");
 strcpy(makerid[132], "KOEI");
 strcpy(makerid[133], "<<Unknown 133>>");
 strcpy(makerid[134], "T.I.M.");
 strcpy(makerid[135], "<<Unknown 135>>");
// strcpy(makerid[136], "DATAM-Polystar");
 strcpy(makerid[136], "Datam Polystar");
 strcpy(makerid[137], "<<Unknown 137>>");
 strcpy(makerid[138], "<<Unknown 138>>");
 strcpy(makerid[139], "Bullet-Proof Software");
 strcpy(makerid[140], "Vic Tokai");
 strcpy(makerid[141], "<<Unknown 141>>");
 strcpy(makerid[142], "Character Soft");
 strcpy(makerid[143], "I'Max");
 strcpy(makerid[144], "Takara");
 strcpy(makerid[145], "Chun Soft");
// strcpy(makerid[146], "Video System Co., Ltd.");
 strcpy(makerid[146], "Video System");
// strcpy(makerid[147], "Interbec");
 strcpy(makerid[147], "Bec");
 strcpy(makerid[148], "<<Unknown 148>>");
 strcpy(makerid[149], "Varie");
 strcpy(makerid[150], "<<Unknown 150>>");
 strcpy(makerid[151], "Kaneco");
 strcpy(makerid[152], "<<Unknown 152>>");
 strcpy(makerid[153], "Pack-In-Video");
 strcpy(makerid[154], "Nichibutsu");
 strcpy(makerid[155], "Tecmo");
 strcpy(makerid[156], "Imagineer");
 strcpy(makerid[157], "<<Unknown 157>>");
 strcpy(makerid[158], "<<Unknown 158>>");
 strcpy(makerid[159], "<<Unknown 159>>");
// Laser Soft, Telenet?
// strcpy(makerid[160], "Wolf Team*");
 strcpy(makerid[160], "Telenet");
 strcpy(makerid[161], "Hori");
 strcpy(makerid[162], "<<Unknown 162>>");
 strcpy(makerid[163], "<<Unknown 163>>");
 strcpy(makerid[164], "Konami");
 strcpy(makerid[165], "K. Amusement Leasing Co.");
 strcpy(makerid[166], "<<Unknown 166>>");
 strcpy(makerid[167], "Takara");
 strcpy(makerid[168], "<<Unknown 168>>");
 strcpy(makerid[169], "Technos");
// strcpy(makerid[170], "Victor Entertainment, Inc.");
 strcpy(makerid[170], "JVC");
 strcpy(makerid[171], "<<Unknown 171>>");
 strcpy(makerid[172], "TOEI Animation");
 strcpy(makerid[173], "Toho");
 strcpy(makerid[174], "<<Unknown 174>>");
// strcpy(makerid[175], "Namco Ltd.");
// strcpy(makerid[175], "Namcot");
 strcpy(makerid[175], "Namco");
 strcpy(makerid[176], "<<Unknown 176>>");
 strcpy(makerid[177], "ASCII");
// strcpy(makerid[178], "BanDai America");
 strcpy(makerid[178], "Bandai");
 strcpy(makerid[179], "<<Unknown 179>>");
 strcpy(makerid[180], "Enix");
 strcpy(makerid[181], "<<Unknown 181>>");
 strcpy(makerid[182], "Halken");
 strcpy(makerid[183], "<<Unknown 183>>");
 strcpy(makerid[184], "<<Unknown 184>>");
 strcpy(makerid[185], "<<Unknown 185>>");
 strcpy(makerid[186], "Culture Brain");
 strcpy(makerid[187], "Sunsoft");
 strcpy(makerid[188], "Toshiba EMI");
 strcpy(makerid[189], "Sony Imagesoft");
 strcpy(makerid[190], "<<Unknown 190>>");
 strcpy(makerid[191], "Sammy");
 strcpy(makerid[192], "Taito");
 strcpy(makerid[193], "<<Unknown 193>>");
 strcpy(makerid[194], "Kemco");
 strcpy(makerid[195], "Square");
 strcpy(makerid[196], "Tokuma Soft");
 strcpy(makerid[197], "Data East");
 strcpy(makerid[198], "Tonkinhouse");
 strcpy(makerid[199], "<<Unknown 199>>");
 strcpy(makerid[200], "KOEI");
 strcpy(makerid[201], "<<Unknown 201>>");
 strcpy(makerid[202], "Konami");
 strcpy(makerid[203], "NTVIC");
 strcpy(makerid[204], "<<Unknown 204>>");
// strcpy(makerid[205], "meldac/KAZe");
 strcpy(makerid[205], "Meldac");
 strcpy(makerid[206], "Pony Canyon");
 strcpy(makerid[207], "Sotsu Agency/Sunrise");
 strcpy(makerid[208], "Disco/Taito");
 strcpy(makerid[209], "Sofel");
// strcpy(makerid[210], "Quest Corp.");
 strcpy(makerid[210], "Quest");
 strcpy(makerid[211], "Sigma*");
 strcpy(makerid[212], "<<Unknown 212>>");
 strcpy(makerid[213], "<<Unknown 213>>");
// Naxat Soft
 strcpy(makerid[214], "Naxat");
 strcpy(makerid[215], "<<Unknown 215>>");
// strcpy(makerid[216], "Capcom Co., Ltd.");
 strcpy(makerid[216], "Capcom");
 strcpy(makerid[217], "Banpresto");
 strcpy(makerid[218], "Tomy");
// strcpy(makerid[219], "BITS/Argonaut");
 strcpy(makerid[219], "Acclaim");
 strcpy(makerid[220], "<<Unknown 220>>");
// Masaya?
 strcpy(makerid[221], "NCS");
// strcpy(makerid[222], "Human Entertainment");
 strcpy(makerid[222], "Human");
// strcpy(makerid[223], "Ringler Studios*");
 strcpy(makerid[223], "Altron");
// strcpy(makerid[224], "Jaleco Ltd.");
 strcpy(makerid[224], "Jaleco");
 strcpy(makerid[225], "<<Unknown 225>>");
 strcpy(makerid[226], "Yutaka");
 strcpy(makerid[227], "<<Unknown 227>>");
 strcpy(makerid[228], "T&Esoft");
// strcpy(makerid[229], "Epoch Co.,Ltd.");
 strcpy(makerid[229], "Epoch");
 strcpy(makerid[230], "<<Unknown 230>>");
 strcpy(makerid[231], "Athena");
 strcpy(makerid[232], "Asmik");
 strcpy(makerid[233], "Natsume");
 strcpy(makerid[234], "King Records");
 strcpy(makerid[235], "Atlus");
// strcpy(makerid[236], "Sony Music Entertainment (Japan) Inc.");
// strcpy(makerid[236], "Sony Music Entertainment (Japan)");
 strcpy(makerid[236], "Sony Music Entertainment");
 strcpy(makerid[237], "<<Unknown 237>>");
 strcpy(makerid[238], "IGS");
 strcpy(makerid[239], "<<Unknown 239>>");
 strcpy(makerid[240], "<<Unknown 240>>");
 strcpy(makerid[241], "Motown Software");
 strcpy(makerid[242], "Left Field Entertainment");
 strcpy(makerid[243], "Beam Software/Extreme");
 strcpy(makerid[244], "TecMagik");
 strcpy(makerid[245], "<<Unknown 245>>");
 strcpy(makerid[246], "<<Unknown 246>>");
 strcpy(makerid[247], "<<Unknown 247>>");
 strcpy(makerid[248], "<<Unknown 248>>");
 strcpy(makerid[249], "Cybersoft");
 strcpy(makerid[250], "<<Unknown 250>>");
 strcpy(makerid[251], "<<Unknown 251>>");
 strcpy(makerid[252], "<<Unknown 252>>");
 strcpy(makerid[253], "<<Unknown 253>>");
 strcpy(makerid[254], "Davidson");
 strcpy(makerid[255], "<<INVALID>>");

 strcpy(cartinfo[0], "ROM only");
 strcpy(cartinfo[1], "ROM and RAM");
 strcpy(cartinfo[2], "ROM and Save RAM");
 strcpy(cartinfo[255], "<<INVALID>>");

 strcpy(countryid[0], "Japan");
 strcpy(countryid[1], "U.S.A.");
 strcpy(countryid[2], "Europe, Australia, Oceania and Asia");
 strcpy(countryid[3], "Sweden");
 strcpy(countryid[4], "Finland");
 strcpy(countryid[5], "Denmark");
 strcpy(countryid[6], "France");
 strcpy(countryid[7], "Holland");
 strcpy(countryid[8], "Spain");
 strcpy(countryid[9], "Germany, Austria and Switzerland");
 strcpy(countryid[10], "Italy");
 strcpy(countryid[11], "Hong Kong and China");
 strcpy(countryid[12], "Indonesia");
 strcpy(countryid[13], "Korea");
 strcpy(countryid[255], "<<INVALID>>");

 strcpy(format[1], "Doctor V64 (swapped)");
 strcpy(format[0], "Original (not swapped)");

 file_ptr=fopen(cmd1, "rb");
 chkiffileexist(file_ptr, cmd1);

 fseek(file_ptr, 0, SEEK_END);
 file_size=ftell(file_ptr);
 fseek(file_ptr, 0, SEEK_SET);
 file_size-=ftell(file_ptr);
 checkminsize(file_size);

	subsize=0.0;
 filesize=(file_size-subsize)/131072.0;
	fseek(file_ptr, 33239+offset, SEEK_SET);
	fread(inchar, sizeof(char), 1, file_ptr);
if ((power=inchar[0])<0)
		power=power+256;
	if (power>22)
		power=0;
	fseek(file_ptr, 0x20, SEEK_SET);
	fread(cartname, (sizeof(cartname)-1), 1, file_ptr);
 cartsize=int((pow(2, power)*1024.0)/131072.0);
 cartname[25]='\0';

 printf("Filename     : %s\n", cmd1);
fseek(file_ptr,0,SEEK_SET);
fread(buffer,1,12,file_ptr);

swapped=guessByteOrder((unsigned char *)buffer);
if(swapped==1)
{
for( x=0;x<strlen(cartname);x=x+2)
{
	buffer2=cartname[x];
	cartname[x]=cartname[x+1];
	cartname[x+1]=buffer2;
}

}


 printf("Game Pak Name: %s\n", cartname);

// Virgin Games, McO'RIVER
 if (countryindex==4)
	if (makerindex==81)
		makerindex=0;

// McO'RIVER
 if (makerindex==146)
	if (countryindex==1)
		strcpy(makerid[146], "McO'RIVER");

// FCI
 if (makerindex==0xce)
	if (countryindex==1)
		strcpy(makerid[0xce], "FCI");

// to show unknown maker
 if ((makerindex<0) || (makerindex>255))
	makerindex=2;

// printf("Licensee     : %s\n", makerid[makerindex]);
// printf("For Use In   : %s\n", countryid[countryindex]);

// if ((countryindex==0) || (countryindex==1))
//        printf(" (NTSC)\n");
// else if (countryindex!=255)
// else if ((countryindex>1) && (countryindex<14))
//        printf(" (PAL)\n");

 printf("File Size    : %4.2f Mbit\n", filesize);


if(!swapped) printf("Image Format : %s\n",format[0]);
else{
	if(swapped==1)  printf("Image Format : %s\n",format[1]);

else printf("Image Format : <<Unknown>>\n");
}

 if ((filesize>int(filesize)) || ((filesize>cartsize) && (cartsize!=0)))
	{
	introsize=(filesize*131072)-(int(filesize)*131072);
	if (introsize==0)
		introsize=(filesize*131072)-(cartsize*131072);
         printf("Intro/Trainer: Yes, %4.0f bytes\n", introsize);
	}
 else
	{
        printf("Intro/Trainer: No\n");
	}
 printf("\n");

}

#include "ucon64.h"
#include "aps.h"
#include "ips.h"
#include "transfer.h"
#include "makesram.h"

int main(int argc, char* argv[])
{
register int x;
int console;

strcpy(arg,argv[0]);
cmd[0]=cmd1[0]=cmd2[0]=cmd3[0]=0;

printf("uCON64 %s\n\n", uconver);

#ifdef LINUX
	if(argc<2||(argv[1][0]=='-'&&argv[1][1]=='-'&&(argv[1][2]=='?'||argv[1][2]=='h')))usage();
#endif
#ifdef MSDOS
	if(argc<2||(argv[1][0]=='/'&&(argv[1][1]=='?'||argv[1][1]=='h')))usage();
#endif

for(x=1;x<argc;x++)
{
#ifdef LINUX
	if(argv[x][0]=='-')
#endif
#ifdef MSDOS
	if(argv[x][0]=='/')
#endif
	{
		strcpy(cmd,&argv[x][1]);
//		if(cmd[0]=='h'||cmd[0]=='H')hirom=1;
//		if(cmd[0]=='f'||cmd[0]=='F')force=1;
//		if(cmd[0]=='q'||cmd[0]=='Q')quiet=1;
		if(cmd[0]=='1'||cmd[0]=='1'||cmd[0]=='2'||cmd[0]=='2'||cmd[0]=='3'||cmd[0]=='3')
		{
			if(cmd[1]!='\0')
				sscanf(&cmd[1],"%x",&port);
		}

	}
	else 
	{
		if(cmd1[0]==0)strcpy(cmd1,argv[x]);
		if(cmd2[0]==0)strcpy(cmd2,argv[x]);
		if(cmd3[0]==0)strcpy(cmd3,argv[x]);
	}
	
	
}







console=whichsystem();
if(console==SNES)
{
	if(!quiet)getcinfo();
	
	if(cmd[0]!=0)switch(cmd[0])
	{
		case 'a': aps();
			  break;
		case 'c': mghconvert();
			  break;
		case 'e': mghbaseline();
			  break;
		case 'h': mghheader();
			  break;
		case 'i': mghips();
			  break;
		case 'j': mghsnesj();
			  break;
		case 'k': snescrack();
			  break;
		case 'p': mghpatch();
			  break;
		case 's': mghchop();
			  break;
		case 'b': mghbtf();
			  break;
		case 'f': mghftb();
			  break;
		case 'l': mghpalfix();
			  break;
		case 'n': mghname();
			  break;
		case 'r': mghslowrom();
			  break;
		case 'w': mghswtospf();
			  break;
		case 'x': mghtoic2();
			  break;
		case 'y': mghfromic2();
			  break;
		default:  usage();
			  break;
	}
}	
if(console==GENESIS)
{
	if(!quiet)getsinfo();
	
	if(cmd[0]!=0)switch(cmd[0])
	{
		case 'a': aps();
			  break;
		case 'c': mghsconvert();
			  break;
		case 'e': mghbaseline();
			  break;
		case 'h': mghsegaheader();
			  break;
		case 'i': mghips();
			  break;
		case 'j': mghsegaj();
			  break;
		case 'p': mghsegap();
			  break;
		case 's': mghssplit();
			  break;
		case 'n': mghsname();
			  break;
		case 'z': mghsconvertbin();
			  break;
		default:  usage();
			  break;
	}
}
if(console==N64)
{
	if(!quiet)getn64info();
	
	if(cmd[0]!=0)switch(cmd[0])
	{
		case '1': transfer(MODE_SEND);
			  break;
		case '2': transfer(MODE_RECEIVE);
			  break;
		case '3': transfer(MODE_INTERACTIVE);
			  break;
		case '4': z64v64();
			  break;
		case '5': makesram();
			  break;
		case 'a': aps();
			  break;
		case 'e': mghbaseline();
			  break;
		case 'i': mghips();
			  break;
		default:  usage();
			  break;
	}
}	
credits();
exit(0);
}
