/*
    This file is part of the source of talk64 V1.5,
    a PC - DoctorV64 communications program
    Copyright (C) 1997  Andreas Sterbenz (stan@sbox.tu-graz.ac.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#ifndef __V64PROTO_H__
#define __V64PROTO_H__ 1

#define SEND_MAX_WAIT 0x300000
#define REC_MAX_WAIT SEND_MAX_WAIT

#define REC_HIGH_NIBBLE 0x80
#define REC_LOW_NIBBLE 0x00

#define SYNC_MAX_CNT 8192
#define SYNC_MAX_TRY 32

void initCommunication(unsigned int port);

int syncHeader(unsigned int baseport);

int checkSync(unsigned int baseport);

int sendBytes(unsigned int baseport, unsigned int len, char data[], int swap);

int receiveBytes(unsigned int baseport, unsigned int len, char data[], int swap);

int sendFilename(unsigned int baseport, char name[]);

int sendFileLen(unsigned int baseport, long len);

int sendUploadHeader(unsigned int baseport, char name[], long len);

int sendDownloadHeader(unsigned int baseport, char name[], long *len);

int sendHeaderExtRec(unsigned int baseport, long offset, long len);

int sendHeaderExtSend(unsigned int baseport, long offset, long len);

int sendHeaderExtPrint(unsigned int baseport, char line, char column);

int sendHeaderExtCall(unsigned int baseport, int address);

#endif
